# coding: utf-8

"""
    Carrier API

    **Seaplane Global Messaging Service**  For information about authentication see [authentication](/docs/authentication)   # noqa: E501

    The version of the OpenAPI document: 1.0.0-beta
    Contact: support@seaplane.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from seaplane.gen.carrier.models.azure_blob_storage_output import AzureBlobStorageOutput
from seaplane.gen.carrier.models.broker import Broker
from seaplane.gen.carrier.models.carrier_output import CarrierOutput
from seaplane.gen.carrier.models.sql_raw import SqlRaw
from seaplane.gen.carrier.models.switch import Switch
from seaplane.gen.carrier.models.sync_response import SyncResponse
from typing import Any, List
from pydantic import StrictStr, Field

OUTPUT_ANY_OF_SCHEMAS = [
    "AzureBlobStorageOutput",
    "Broker",
    "CarrierOutput",
    "SqlRaw",
    "Switch",
    "SyncResponse",
    "object",
]


class Output(BaseModel):
    """
    Output
    """

    # data type: AzureBlobStorageOutput
    anyof_schema_1_validator: Optional[AzureBlobStorageOutput] = None
    # data type: Broker
    anyof_schema_2_validator: Optional[Broker] = None
    # data type: CarrierOutput
    anyof_schema_3_validator: Optional[CarrierOutput] = None
    # data type: SqlRaw
    anyof_schema_4_validator: Optional[SqlRaw] = None
    # data type: Switch
    anyof_schema_5_validator: Optional[Switch] = None
    # data type: SyncResponse
    anyof_schema_6_validator: Optional[SyncResponse] = None
    # data type: object
    anyof_schema_7_validator: Optional[Dict[str, Any]] = Field(
        None, description="Value may be missing"
    )
    actual_instance: Any
    any_of_schemas: List[str] = Field(OUTPUT_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs):
        if args:
            if len(args) > 1:
                raise ValueError(
                    "If a position argument is used, only 1 is allowed to set `actual_instance`"
                )
            if kwargs:
                raise ValueError(
                    "If a position argument is used, keyword arguments cannot be used."
                )
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator("actual_instance")
    def actual_instance_must_validate_anyof(cls, v):
        if v is None:
            return v

        instance = Output.construct()
        error_messages = []
        # validate data type: AzureBlobStorageOutput
        if not isinstance(v, AzureBlobStorageOutput):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `AzureBlobStorageOutput`"
            )
        else:
            return v

        # validate data type: Broker
        if not isinstance(v, Broker):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Broker`")
        else:
            return v

        # validate data type: CarrierOutput
        if not isinstance(v, CarrierOutput):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `CarrierOutput`"
            )
        else:
            return v

        # validate data type: SqlRaw
        if not isinstance(v, SqlRaw):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SqlRaw`")
        else:
            return v

        # validate data type: Switch
        if not isinstance(v, Switch):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Switch`")
        else:
            return v

        # validate data type: SyncResponse
        if not isinstance(v, SyncResponse):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `SyncResponse`"
            )
        else:
            return v

        # validate data type: object
        try:
            instance.anyof_schema_7_validator = v
            return v
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if error_messages:
            # no match
            raise ValueError(
                "No match found when setting the actual_instance in Output with anyOf schemas: AzureBlobStorageOutput, Broker, CarrierOutput, SqlRaw, Switch, SyncResponse, object. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Output:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Output:
        """Returns the object represented by the json string"""
        instance = Output.construct()
        if json_str is None:
            return instance

        error_messages = []
        # anyof_schema_1_validator: Optional[AzureBlobStorageOutput] = None
        try:
            instance.actual_instance = AzureBlobStorageOutput.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[Broker] = None
        try:
            instance.actual_instance = Broker.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[CarrierOutput] = None
        try:
            instance.actual_instance = CarrierOutput.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[SqlRaw] = None
        try:
            instance.actual_instance = SqlRaw.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_5_validator: Optional[Switch] = None
        try:
            instance.actual_instance = Switch.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # anyof_schema_6_validator: Optional[SyncResponse] = None
        try:
            instance.actual_instance = SyncResponse.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into object
        try:
            # validation
            instance.anyof_schema_7_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.anyof_schema_7_validator
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into Output with anyOf schemas: AzureBlobStorageOutput, Broker, CarrierOutput, SqlRaw, Switch, SyncResponse, object. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            return json.dumps(self.actual_instance)

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())
